void setup()
{
  //Load the images
  charUp = loadImage("C-Up.png");
  charDown = loadImage("C-Down.png");
  charLeft = loadImage("C-Left.png");
  charRight = loadImage("C-Right.png");
  fireballImg = loadImage("Fireball.png");
  fireballs = new ArrayList();
  character = charDown;
  //Create the window with size
  size(windowX,windowY);
  //Set background color
  background(0);
  //Prepare font for on sreen text
  PFont fontA = loadFont("Courier.vlw");
  textFont(fontA, 14);
  //Set framerate of the draw method
  frameRate(60);
}

void draw(){
  //Determine which way to move
  float moveX = 0;
  float moveY = 0;
  if (left) {moveX -= speed;}
  if (right) {moveX += speed;}
  if (up) {moveY -= speed;}
  if (down) {moveY += speed;}
  if (x+moveX > 0 && x+moveX < windowX) {x += moveX;}
  if (y+moveY > 0 && y+moveY < windowY) {y += moveY;}
  
  //If pressing certain arrows, set the character's direction
  if (left) {dir = DirLEFT; character = charLeft;}
  if (right) {dir = DirRIGHT; character = charRight;}
  if (down) {dir = DirDOWN; character = charDown;}
  if (up) {dir = DirUP; character = charUp;}
  if (left && up) {dir = DirUPLEFT;}
  if (right && up) {dir = DirUPRIGHT;}
  if (left && down) {dir = DirDOWNLEFT;}
  if (right && down) {dir = DirDOWNRIGHT;}
  
  //If spacebar is pressed, handle shooting
  if (fire) {
    fireballTimer += 1;
    if (fireballTimer > fireballTimerMax) {
      fireballTimer = 0;
      float velx = 0;
      float vely = 0;
      float s = 10;
      //Use character's direction to determine velocity
      if (dir == DirLEFT) {velx = -s;}
      if (dir == DirRIGHT) {velx = s;}
      if (dir == DirUP) {vely = -s;}
      if (dir == DirDOWN) {vely = s;}
      if (dir == DirUPLEFT) {velx = -s;vely = -s;}
      if (dir == DirUPRIGHT) {velx = s;vely = -s;}
      if (dir == DirDOWNLEFT) {velx = -s;vely = s;}
      if (dir == DirDOWNRIGHT) {velx = s;vely = s;}
      //Set the fireball's position and velocity
      fireballs.add(new Fireball(x, y, velx, vely));
    }
  }
  //Set background color
  background(0);
  //Draw instruction text
  text("Arrow keys to move and space to shoot!",5,15);
  //Draw main character
  image(character, x- charWidth/2, y-charHeight/2);
  //Draw all the fireballs and handle their logic
  for (int i = fireballs.size()-1; i > 0; i--) { 
    // An ArrayList doesn't know what it is storing,
    // so we have to cast the object coming out.
    Fireball ball = (Fireball) fireballs.get(i);
    ball.move();
    ball.display();
    if (ball.finished()) {
      //Remove fireball if it's done
      fireballs.remove(i);
      i -=1;
    }
  }
}

void keyPressed()
{
  if(key == CODED)
  {
    if (keyCode == LEFT)
    {
      left = true;
    }
    if(keyCode == RIGHT)
    {
      right = true;
    }
    if (keyCode == UP)
    {
      up = true;
    }
    if(keyCode == DOWN)
    {
      down = true;
    }
  } else {
    if(key == ' ')
    {
      fire = true;
    }
  }
}

void keyReleased() {
  if(key == CODED)
  {
    if (keyCode == LEFT)
    {
      left = false;
    }
    if(keyCode == RIGHT)
    {
      right = false;
    }
    if (keyCode == UP)
    {
      up = false;
    }
    if(keyCode == DOWN)
    {
      down = false;
    }
  } else {
    if(key == ' ')
    {
      fire = false;
    }
  }
}
